<!DOCTYPE html>
<html lang="en">
  <%- include('./components/head') %>
  <body>
    <script src="https://www.google.com/recaptcha/api.js" async defer></script>
    <div class="container-scroller">
      <!-- partial:partials/_sidebar.html -->
      <%- include('./components/sidebar') %>
      <!-- partial -->
      <div class="container-fluid page-body-wrapper">
        <!-- partial:partials/_navbar.html -->
        <%- include('./components/topnav') %>
        <!-- partial -->
        <div class="main-panel">
          <div style="background-color: #111319" class="content-wrapper">
           <h2>Deploy Server</h2>
           <p class="text-gray">Deploy your new server.</p>
            <% if (req.query.err) { %>
            <div style="border-radius: 15px;" class="alert">
                <% if (req.query.err == "MISSINGVARIABLE") { %>
                    You have not filled out all of the server information.
                <% } else if (req.query.err == "NOTANUMBER") { %>
                    RAM, disk and CPU must be a number.
                <% } else if (req.query.err == "ERRORONCREATE") { %>
                    An error was reported by the Panel while attempting to create the server.
                <% } else if (req.query.err == "BIGSERVERNAME") { %>
                    Your server name must be less than <b>191</b> characters.
                <% } else if (req.query.err == "TOOMUCHSERVERS") { %>
                    Too many servers!
                <% } else if (req.query.err == "PREMIUMLOCATION") { %>
                    Please select a location.
                <% } else if (req.query.err == "TOOLITTLECOINS") { %>
                    You do not have enough coins to create a server
                <% } else if (req.query.err == "MUSTCOMPLETECAPTCHA") { %>
                    You must complete the captcha to prove you are human!
                <% } else if (req.query.err == "INVALIDCAPTCHARESPONSE") { %>
                    You submitted an invalid captcha response, try again.
                <% } else { %>
                    <% if (req.query.num) { %>
                        <% if (!isNaN(parseFloat(req.query.num))) { %>
                            <% if (req.query.err == "TOOLITTLERAM" || req.query.err == "TOOLITTLEDISK" || req.query.err == "TOOLITTLECPU") { %>
                                You must make a server with at least <b><%= req.query.num %></b>
                                <% if (req.query.err.slice(-3) == "RAM") { %>
                                    MB RAM
                                <% } else if (req.query.err.slice(-4) == "DISK") { %>
                                    MB disk
                                <% } else { // CPU %>
                                    % CPU
                                <% } %>
                                if you want to create a server with the server type you have selected.
                            <% } else if (req.query.err == "TOOMUCHRAM" || req.query.err == "TOOMUCHDISK" || req.query.err == "TOOMUCHCPU") { %>
                                With the selected server type, you can have a maximum of <b><%= req.query.num %></b>
                                <% if (req.query.err.slice(-3) == "RAM") { %>
                                    MB RAM
                                <% } else if (req.query.err.slice(-4) == "DISK") { %>
                                    MB disk
                                <% } else { // CPU %>
                                    % CPU
                                <% } %>
                                on the server.
                            <% } else if (req.query.err == "EXCEEDRAM" || req.query.err == "EXCEEDDISK" || req.query.err == "EXCEEDCPU") { %>
                                You don't have enough resources to make this server.
                            <% } else { %>
                                I won't mind to add a little easter egg here. :)
                            <% } %>
                        <% } else { %>
                            I won't mind to add a little easter egg here. :)
                        <% } %>
                    <% } else { %>
                        I won't mind to add a little easter egg here. :)
                    <% } %>
                <% } %>
            </div>
        <% } %>
            <div class="row">
              <div class="col-md-6 grid-margin stretch-card">
                <div class="card">
                  <div class="card-body">
                    <form class="forms-sample">
                      <div class="form-group">
                        <label for="InputName">Server Name:</label>
                        <input style="border-radius: 15px; padding: 8px;" type="text" class="form-control" id="InputName" placeholder="My Server">
                      </div>
                      <div class="form-group">
                        <label for="InputCPU">CPU (Cores):</label>
                        <input style="border-radius: 15px; padding: 8px;" type="number" class="form-control" id="InputCPU" placeholder="1">
                      </div>
                      <div class="form-group">
                        <label for="InputRAM">RAM (GBs):</label>
                        <input style="border-radius: 15px; padding: 8px;" type="number" class="form-control" id="InputRAM" placeholder="2">
                      </div>
                      <div class="form-group">
                        <label for="InputDisk">Disk (GBs):</label>
                        <input style="border-radius: 15px; padding: 8px;" type="number" class="form-control" id="InputDisk" placeholder="40">
                      </div>
                      <div class="form-group">
                        <label for="InputLoc">Location:</label><BR>
                        <select class="btn btn-secondary dropdown-toggle" style="background-color: #2a3038; border: 1px solid #2c2e33; color: #e4eaec; border-radius: 15px; padding: 8px;" id="InputLoc">
                          <% for (let [name, value] of Object.entries(settings.api.client.locations)) { %>
                            <option value="<%= name %>"><%= value.name %></option>
                          <% } %>
                        </select>
                      </div>
                      <div class="form-group">
                        <label for="InputEgg">Egg:</label><BR>
                        <select class="btn btn-secondary dropdown-toggle" style="background-color: #2a3038; border: 1px solid #2c2e33; color: #e4eaec; border-radius: 15px; padding: 8px;" id="InputEgg">
                          <% for (let [name, value] of Object.entries(settings.api.client.eggs)) { %>
                            <option value="<%= name %>"><%= value.display %></option>
                          <% } %>
                        </select>
                      </div>
                      <a role="button" id="create-btn" class="btn btn-primary btn-lg" href="javascript: submitNew()">Deploy Server</a>
                      <br><br><p style="text-muted">Your first server is free, after that it will cost <code style="color: #007fcc" ><%= settings.servercreation.cost %> coins</code>!</p>
                    </form>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <!-- content-wrapper ends -->
          <%- include('./components/footer') %>
        </div>
        <!-- main-panel ends -->
      </div>
      <!-- page-body-wrapper ends -->
    </div>
    <!-- container-scroller -->
    <!-- plugins:js -->
    <script src="../../assets/vendors/js/vendor.bundle.base.js"></script>
    <!-- endinject -->
    <!-- Plugin js for this page -->
    <script src="../../assets/vendors/select2/select2.min.js"></script>
    <script src="../../assets/vendors/typeahead.js/typeahead.bundle.min.js"></script>
    <script>
      async function submitNew() {
        let name = encodeURIComponent(document.getElementById("InputName").value);
        let egg = encodeURIComponent(document.getElementById("InputEgg").value);
        let ram = encodeURIComponent(document.getElementById("InputRAM").value * 1024);
        let disk = encodeURIComponent(document.getElementById("InputDisk").value * 1024);
        let cpu = encodeURIComponent(document.getElementById("InputCPU").value * 100);
        let location = encodeURIComponent(document.getElementById("InputLoc").value);
        document.location.href = `/create?name=${name}&egg=${egg}&ram=${ram}&disk=${disk}&cpu=${cpu}&location=${location}`;
      };
    </script>
    <!-- End plugin js for this page -->
    <!-- inject:js -->
    <script src="/assets/js/off-canvas.js"></script>
    <script src="/assets/js/hoverable-collapse.js"></script>
    <script src="/assets/js/misc.js"></script>
    <script src="/assets/js/settings.js"></script>
    <script src="/assets/js/todolist.js"></script>
    <!-- endinject -->
    <!-- Custom js for this page -->
    <script src="/assets/js/file-upload.js"></script>
    <script src="/assets/js/typeahead.js"></script>
    <script src="/assets/js/select2.js"></script>
    <!-- End custom js for this page -->
  </body>
</html>
